# addexr_alf04.awk

function trim(s)
{
	sub(/^[ \t]*/,"",s)
	sub(/[ \t]*$/,"",s)
	return s
}

function clip(s)
{
	sub(/[ \t]*$/,"",s)
	return s
}



function ld_extnnamesfile(extnnamesfile) {
	printf("ld_extnnamesfile(%s)\n", extnnamesfile)
	system("date")
	extnnamesid = 0
	while ( (getline aline < extnnamesfile) > 0 ) {
		++extnnamesid
		split(aline, a_arr, "|")
		printf("aline=%s\n", aline)
		f = 0
		familyname = toupper(trim(a_arr[++f]))
		givenname = toupper(trim(a_arr[++f]))
		department = toupper(trim(a_arr[++f]))
		position = toupper(trim(a_arr[++f]))
		location = toupper(trim(a_arr[++f]))
		extn = clip(a_arr[++f])

		extn_to_extnnamesid_arr[extn] = extnnamesid
		extnnamesid_to_familyname_arr[extnnamesid] = familyname
		extnnamesid_to_givenname_arr[extnnamesid] = givenname
		extnnamesid_to_department_arr[extnnamesid] = department
		extnnamesid_to_position_arr[extnnamesid] = position
		extnnamesid_to_location_arr[extnnamesid] = location

		print "    extn_to_extnnamesid_arr[" extn "] = [" extn_to_extnnamesid_arr[extn] "]"
		print "    extnnamesid_to_familyname_arr[" extnnamesid "] = [" extnnamesid_to_familyname_arr[extnnamesid] "]"
		print "    extnnamesid_to_givenname_arr[" extnnamesid "] =  [" extnnamesid_to_givenname_arr[extnnamesid] "]"

	}
	close(extnnamesfile)
}


#----------

function in_dir(site,extn)
{
	sql1 = "select count(*) from directtemplate"
	sql1 = sql1 " where site = '" site "' and extension = " extn
	#print "sql1 = [" sql1 "]"
	cmd1 = "txsql -q \"" sql1 "\""
	cmd1 | getline res1
	close(cmd1)
	#print "res1 = [" res1 "]"
	split(res1, res1_arr, "|")
	return res1_arr[1]
}


#----------

function dorange(site,fgroup,loextn,hiextn,extgroupunique, surname, firstname)
{
	for ( extension = loextn; extension <= hiextn; ++extension ) {
		extnnamesid = extn_to_extnnamesid_arr[extension]

		if ( in_dir(site,extension) )
			continue

		#recordno
		familyname = extnnamesid_to_familyname_arr[extnnamesid]
		givenname = extnnamesid_to_givenname_arr[extnnamesid]
		speeddial = ""
		extnstr = sprintf("%05d", extension);
		telephone = "03 907" substr(extnstr,1,1) " " substr(extnstr,2,4);
		title = ""
		fulltitle = ""
		position = extnnamesid_to_position_arr[extnnamesid]
		department = extnnamesid_to_department_arr[extnnamesid]
		location = extnnamesid_to_location_arr[extnnamesid]
		privatemobile = ""
		filt_privatemobile = ""
		companymobile = ""
		filt_companymobile = ""
		roomsphone = ""
		filt_roomsphone = ""
		faxno = ""
		filt_faxno = ""
		homephone = ""
		filt_homephone = ""
		extpagerno = ""
		weekendphone = ""
		filt_weekendphone = ""
		intpagerno = ""
		empid = ""
		email = ""
		printed_listed = "N"
		web_listed = "Y"
		secure_code  = "Y"
		master  = "Y"
		terminated = ""
		#date_updated = "06/05/2009"
		date_updated = today

		if ( extnnamesid == "" ) {
			#familyname = "UNKNOWN"
			#givenname = ""
			familyname = surname
			givenname = firstname
			position = ""
			department = ""
			location = ""
			web_listed = "N"
		}

		printf( \
"%d|%s||||||%s|||||%d|||||||%s||||||||||%s|||||\n", recordno, secure_code, extgroupunique, extension, fgroup, site ) >> "dt.add";
		printf( \
"%d|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|\n", \
			recordno, familyname, givenname, speeddial, telephone, \
			title, fulltitle, position, department, location, \
			privatemobile, filt_privatemobile, \
			companymobile, filt_companymobile, \
			roomsphone, filt_roomsphone, \
			faxno, filt_faxno, \
			homephone, filt_homephone, \
			extpagerno, \
			weekendphone, filt_weekendphone, intpagerno, \
			empid, email, \
			printed_listed, web_listed, master, terminated, \
			date_updated) >> "dc.add";
		++recordno;
	}
}

BEGIN {
	cmd1 = "date \"+%d/%m/%Y\""
	cmd1 | getline today
	close(cmd1)
	print "today is " today
	#ld_extnnamesfile("alc_dir_23112006.unl");
	recordno = 64000;
	##dorange(site,fgroup,loetxn,hietxn,extgroupunique);
	##dorange("ALC", "O", 60200, 60299, "ALCGROUP");
	##dorange("ALC", "O", 60300, 60399, "ALCGROUP");

	#dorange("ALC", "O", 60300, 60389, "A0904L", "UNKNOWN", "");
	#dorange("ALF", "O", 60390, 60399, "A0904A", "UNKNOWN", "");

	#dorange("ALC", "O", 60400, 60445, "Y7503L", "UNKNOWN", "");
	#dorange("ALF", "O", 60446, 60499, "Y7503A", "UNKNOWN", "");

	#dorange("ALC", "O", 60600, 60799, "A5654L", "UNKNOWN", "");

	#dorange("ALC", "O", 68100, 68150, "R0256L", "UNKNOWN", "");

	# 14/10/2009
	dorange("ALC", "O", 60100, 60199, "R2402L", "UNKNOWN", "");
}

